
kActor@ boss;
bool bBossFightActive = false;
kStr GVK_BossHealth = "BossHealth";

bool bDebug;

const int KeyType  = 440; // key actor type
const int KeyLevel =   2; // which level keys unlock (key panel TID and displayed key style)

int CreditTextCountdown;

enum TIDs
{
	TID_NewGame = 100,
	// 1000 - starting area (including starting cave)
		// ambushers
	// 2000 - cave (key path)
		// rising ambusher
		// falling ambusher (unused)
		// shaman gate
		// falling ambusher (unused)
		// leaper gate
		// key guards
		// save point
		// teleporter
		// teleporter gate event
		TID_KeyCave_Gate_First = 2009,
		TID_KeyCave_Gate_Last  = TID_KeyCave_Gate_First + 2,
	// 3000 - outside settlement
		// 3000 - water ruin area
			TID_Ruin_Button_Event = 3000,
			TID_Ruin_Button_Actors, // button, gates, enemies
			TID_Ruin_Pillar1,
			TID_Ruin_Pillar2,
			TID_Ruin_Pillar3,
			TID_Ruin_Pillar4,
		// 3100 - outside entrance
			TID_Outside_Secret_Event = 3100,
			TID_Outside_Secret_Sparkles,
			TID_Outside_Secret_Prize,
		// 3500 - cliffs area
			// island1 ambusher
			// island2 ambusher
			// ledge ambushers
			// big island ambushers
			// return ambushers
			// big island button
			TID_Cliffs_Checkpoint = 3506,
			// cliff checkpoint event
			// 3900 - secret elevator
	// 4000 - inside settlement
		TID_Settlement_Entry_Event = 4000,
		TID_Settlement_Entry_Ambushers1,
		TID_Settlement_Entry_Ambushers2,
		TID_Settlement_SavePoint,
		TID_Settlement_KeyGate,
		TID_Settlement_SecretHouse,
		TID_Settlement_KeyReinforcements,
		TID_Settlement_MazePurlin,
		TID_Settlement_SewerEntry,
		TID_Settlement_SewerCheckpoint,
	// 5000 - maze (5xyt - right to left, bottom to top, tag)
	// 6000 - temple
		// 6000 - outside + entryway
			// teleporter
			// save point
			// key panel event
			TID_Temple_Entrance = 6003,
			// monkey
		// 6100 - left branch
			// entrance door
			// shaman gate
			// arena button
		// 6200 - right branch
			// entrance door
			// fire traps
			// closet
			// exit guard + door
			// exit door (old, no longer used)
			// arena button
		// 6300 - arena
			TID_Arena_Boss_Event = 6300,
			TID_Arena_Boss_Tick,
			TID_Arena_Boss,
			TID_Arena_Gate,  // movers in front of portal
			TID_Arena_Portal,
			TID_Arena_Portal_Event,
			TID_Arena_Credits,
			TID_Arena_Checkpoint,
			TID_Arena_Wave1 = 6310, // warriors
			TID_Arena_Wave2 = 6320, // barbarians
			TID_Arena_Wave3 = 6330, // pur-lins
			TID_Arena_Wave4 = 6340, // shamans
			TID_Arena_Wave5 = 6350, // sergeants
	// 10000 - secret markers
		TID_SecretMarker_Start = 10000,
		TID_SecretMarker_Outside = TID_SecretMarker_Start,
		TID_SecretMarker_Sewer,
		TID_SecretMarker_Cliff,
		TID_SecretMarker_House,
		TID_SecretMarker_Temple,
		TID_SecretMarker_End
}

// TID probe
$script 500
{
	kStr found;
//	for ( int i=0; i<1000000; ++i )
	for ( int i=0; i<10000; ++i )
	{
		if ( World.GetActorByTID( i ) !is null )
		{
			found = found +' '+ i;
			if ( i == 100 )
			{
				Sys.Print( ""+ World.GetActorByTID( i ).Type() );
				Player.Actor().Origin() = World.GetActorByTID( i ).Origin();
			}
		}
	}
	Sys.Print( found );
}

bool FirstTrigger()
{
	return Player.Actor().Flags() & AF_ENTEREDAREAEVENT == 0;
}

//==============================================================================
// Level Startup
//==============================================================================

$script 0
{
	kStr str;
	bDebug = Sys.GetCvarValue( "developer", str ) && str.Atoi() != 0;

	if ( bDebug ) Sys.Print( "Level Startup" );

	@boss = World.GetActorByTID( TID_Arena_Boss );
	if ( boss !is null && boss.IsStale() )
		@boss = null;

	NewGame();

	// check water ruin button
	kActor@ a = World.GetActorByTID( TID_Ruin_Button_Actors, 300 ); // button actor
	if ( a !is null && a.IsPersistentMarked() )
		Game.CallDelayedMapScript( TID_Ruin_Button_Event, instigator, 0 );

	// check secret outside settlment entrace
	@a = World.GetActorByTID( TID_SecretMarker_Outside );
	// hide prize if not found
	if ( a is null || !a.IsPersistentMarked() )
	{
		@a = World.GetActorByTID( TID_Outside_Secret_Prize );
		if ( a !is null && !a.IsPersistentMarked() )
			a.Flags() |= AF_HIDDEN;
	}
	// else hide sparkles
	else
	{
		@a = World.GetActorByTID( TID_Outside_Secret_Sparkles );
		if ( a !is null && !a.IsPersistentMarked() )
			a.Origin().z -= 100;
	}

	// settlement
	// key gate reinforcements
	@a = World.GetActorByTID( TID_Settlement_KeyGate, 300 ); // key gate button
	if ( a !is null && a.IsPersistentMarked() )
		World.TriggerActorsByTID( instigator, TID_Settlement_KeyGate );
	// key acquisition reinforcements
	@a = World.GetActorByTID( 1, KeyType ); // key actor
	if ( a is null || a.IsPersistentMarked() )
		World.TriggerActorsByTID( instigator, TID_Settlement_KeyReinforcements );

	// undo level exit teleport flag
	@a = World.GetActorByTID( TID_Arena_Portal );
	if ( a !is null )
		World.ChangeAreaFlag( a.AreaID(), AAF_TELEPORT, false );
}

void NewGame()
{
	// g_newgame isn't set when starting with "map" console command, or "-runmap" launch param
	// using a dummy actor's persistent bit should cover pretty much all possible methods of starting the map
	kActor@ a = World.GetActorByTID( TID_NewGame );
	if ( a is null || a.IsPersistentMarked() )
		return;
	if ( bDebug ) Sys.Print( "New Game" );
	a.MarkPersistentBit( false );

	GameVariables.SetValue( "chronoPieceFlags", "0" );
	for ( int i=1; i<=7; ++i )
		GameVariables.SetValue( "hubPanelPieces" + i, "0" );

	int health = boss !is null ? boss.SpawnParams(2) : 0; // initial health
	if ( GameVariables.HasKey( GVK_BossHealth ) )
		GameVariables.SetValue( GVK_BossHealth, ""+ health );
	else
		GameVariables.Add( GVK_BossHealth, ""+ health );
}

//==============================================================================
// Key Cave
//==============================================================================

// Teleporter Gate Event
// teleporting out before gate finishes opening causes sound to get stuck until
// you move out of range of the sound, or move back in range of the movers
// so prevent them from going dormant while they're moving
$script 2008
{
	if ( !FirstTrigger() ) return;

	// trigger gate movers, and prevent going dormant
	int moveTime = -1;
	for ( int i = TID_KeyCave_Gate_First; i <= TID_KeyCave_Gate_Last; ++i )
	{
		kActor@ a = World.GetActorByTID( i );
		if ( a is null || a.IsPersistentMarked() ) continue;
		a.Flags() &= ~AF_DORMANT;
		a.Flags() |= AF_ALWAYSACTIVE;
		World.TriggerActorsByTID( instigator, i );
		if ( a.SpawnParams(4) > moveTime ) moveTime = a.SpawnParams(4);
	}

	// if any movers were activated, wait for them to stop (plus some buffer time), then force them dormant
	if ( moveTime < 0 ) return;
	delay( moveTime > 0 ? moveTime * 1.5f : 1.5f );
	for ( int i = TID_KeyCave_Gate_First; i <= TID_KeyCave_Gate_Last; ++i )
	{
		kActor@ a = World.GetActorByTID( i );
		if ( a !is null ) a.Flags() |= AF_DORMANT;
	}
}

//==============================================================================
// Water Ruin
//==============================================================================

// Button Event
$script 3000
{
	if ( !FirstTrigger() ) return;
	// trigger the button, gates, enemies
	World.TriggerActorsByTID( instigator, TID_Ruin_Button_Actors );
	// handle water pillars
	for ( int i=TID_Ruin_Pillar1; i<=TID_Ruin_Pillar4; ++i )
	{
		kActor@ pillar = World.GetActorByTID( i );
		if ( pillar is null ) continue;
		// raise the pillar
		World.TriggerActorsByTID( instigator, i );
		// clear water flag so it won't splash when we stand on it
		World.FloodMatchingAreaFlags( pillar.SectorIndex(), AAF_WATER, false );
	}
}

// Outside Secret
$script 3100
{
	if ( !FirstTrigger() ) return;
	// reveal prize
	kActor@ a = World.GetActorByTID( TID_Outside_Secret_Prize );
	if ( a !is null && a.Flags() & AF_HIDDEN != 0 )
	{
		a.SpawnFx( "fx/generic_260.kfx", Math::vecZero );
		a.Flags() &= ~AF_HIDDEN;
	}
	// hide sparkles
	@a = World.GetActorByTID( TID_Outside_Secret_Sparkles );
	if ( a !is null )
		a.Origin().z -= 100; // removing actor or setting various flags has no effect, so just move out of view
	// trigger the secret marker
	World.TriggerActorsByTID( instigator, TID_SecretMarker_Outside );
}

//==============================================================================
// Settlement
//==============================================================================

// Entry Event
$script 4000
{
	if ( !FirstTrigger() ) return;
	// first visit ambushers - always activate
	World.TriggerActorsByTID( instigator, TID_Settlement_Entry_Ambushers1 );
	// second visit ambushers - activate if key gate is open
	kActor@ a = World.GetActorByTID( TID_Settlement_KeyGate, 300 ); // button
	if ( a !is null && a.IsPersistentMarked() )
		World.TriggerActorsByTID( instigator, TID_Settlement_Entry_Ambushers2 );
}

// Sewer Entry
$script 4008
{
	if ( !FirstTrigger() ) return;
	// enable cliff area checkpoint on final landing platform
	// (starts disabled because it has no meaning when approaching from the mainland side)
	kActor@ a = World.GetActorByTID( TID_Cliffs_Checkpoint ); // warp point
	if ( a !is null )
		World.FloodMatchingAreaFlags( a.SectorIndex(), AAF_CHECKPOINT, true );
}

// Cliff Checkpoint
$script 3507
{
	if ( !FirstTrigger() ) return;
	// disable checkpoint after the player activates it
	// (in case player returns after activating another check/savepoint without reloading the map or going through the sewer)
	delay( 0 ); // wait a tick for checkpoint activation to register
	kActor@ a = World.GetActorByTID( TID_Cliffs_Checkpoint ); // warp point
	if ( a !is null )
		World.FloodMatchingAreaFlags( a.SectorIndex(), AAF_CHECKPOINT, false );
}

//==============================================================================
// Maze
//==============================================================================

// on the way out from key
$script 5530
{
	if ( !FirstTrigger() ) return;
	kActor@ a = World.GetActorByTID( 2, KeyType ); // key
	if ( a is null || a.IsPersistentMarked() )
		World.TriggerActorsByTID( instigator, 5531 ); // ambushers
}

//==============================================================================
// Temple
//==============================================================================

// Key Panel Event
$script 6002
{
	int nKeys, nLeft, foundBits;
	if ( !Game.GetHubKeyInfo( KeyLevel, nKeys, nLeft, foundBits ) )
		return;

	// print status if not all keys are found
	// (kPlayLoop::CheckKeys() adds 2 new lines every time, so do it manually on top 2 lines)
	nLeft = 3 - (foundBits & 1) - (foundBits >> 1 & 1) - (foundBits >> 2 & 1);
	if ( nLeft > 1 )
	{
		Game.PrintLine( "$str_001", 0 );
		Game.PrintLine( ""+ nLeft +" "+ Game.GetLocalizedText("$str_000"), 1 );
	}
	else if ( nLeft > 0 )
	{
		Game.PrintLine( "$str_003", 0 );
		Game.PrintLine( "$str_002", 1 );
	}

	if ( !FirstTrigger() ) return;

	// check if player has more keys to plug in
	int pluggedBits;
	if ( !GameVariables.GetInt( "hubPanelPieces"+ (KeyLevel-1), pluggedBits ) || pluggedBits == foundBits )
		return;
	GameVariables.SetValue( "hubPanelPieces"+ (KeyLevel-1), ""+ foundBits );

	// plug keys into the panel
	kActor@a = World.GetActorByTID( KeyLevel, 318 );
	if ( a !is null )
	{
		a.PlaySound( "sounds/shaders/health_pickup_1.ksnd" );
		for ( int i=0; i<3; ++i )
			a.RenderModel().SetVisibility( i+1, foundBits & (1<<i) != 0 );
	}

	// open door if all keys are in
	if ( nLeft <= 0 )
		World.TriggerActorsByTID( instigator, TID_Temple_Entrance );
}

//==============================================================================
// Boss Arena
//==============================================================================

// Entry Event
$script 6300
{
	if ( !FirstTrigger() || bBossFightActive )
		return;
	if ( boss !is null )
	{
		PlayLoop.TagActorForBossBar( boss );
		GameVariables.GetInt( GVK_BossHealth, boss.Health(), boss.Health() );
	}
	bBossFightActive = true;
	Game.CallDelayedMapScript( TID_Arena_Boss_Tick, instigator, 0 );
}

// Boss Tick
$script 6301
{
	int health = 0, max = 0;
	if ( boss !is null && !boss.IsStale() )
	{
		max = boss.SpawnParams(2); // initial health
		health = boss.Health();
		if ( GameVariables.HasKey(GVK_BossHealth) )
			GameVariables.SetValue( GVK_BossHealth, ""+ health );
		else
			GameVariables.Add( GVK_BossHealth, ""+ health );
	}

	World.TriggerActorsByTID( instigator, TID_Arena_Wave1 );
	if ( health <= max/5 * 4 )
		World.TriggerActorsByTID( instigator, TID_Arena_Wave2 );
	if ( health <= max/5 * 3 )
		World.TriggerActorsByTID( instigator, TID_Arena_Wave3 );
	if ( health <= max/5 * 2 )
		World.TriggerActorsByTID( instigator, TID_Arena_Wave4 );
	if ( health <= max/5 )
		World.TriggerActorsByTID( instigator, TID_Arena_Wave5 );

	if ( health > 0 )
		$restart;
	else
		PlayLoop.RemoveBossActor();
}

// Level Exit
$script 6305
{
	if ( !FirstTrigger() ) return;
	Camera.StartCinematic( CMF_LOCK_PLAYER|CMF_NO_LETTERBOX );
	Camera.ClearLookAtActor();
	Camera.ClearFinalView();
	Camera.ClearViewTracks();
	Camera.fov = 74;
	Camera.origin = kVec3( 234, -665, -64 ) * GAME_SCALE;
	Camera.pitch = Math::Deg2Rad( 20 );
	Camera.yaw   = Math::Deg2Rad( 50 );
	Game.CallDelayedMapScript( TID_Arena_Credits, instigator, 0 );
	CreditTextCountdown = 1;
}

// Credits
$script 6306
{
	if ( Camera.UserInterrupted() )
	{
		Game.Restart();
		return;
	}
	// first tick of fading in
	if ( Camera.CinematicState() == 2 && CreditTextCountdown > 0 )
	{
		// bring player along to change music and wake up any nearby actors
//		Player.Actor().Origin() = Camera.origin; // updates neither music nor fog
		Player.Actor().SetPosition( Camera.origin ); // updates music, but not fog
		Player.Actor().Pitch()  = Camera.pitch;
		Player.Actor().Yaw()    = Camera.yaw;
		// clear out any lingering text before the secret display
		for ( int i=0; i<10; ++i )
			Game.PrintLine( "", 0, 0 );
		CreditTextCountdown = -1;
	}
	// after fade in
	else if ( Camera.CinematicState() > 2 )
	{
		// wait for text appear animation
		if ( CreditTextCountdown > 0 )
		{
			--CreditTextCountdown;
			$restart;
			return;
		}
		// first text display; setup refresh delay
		else if ( CreditTextCountdown < 0 )
			CreditTextCountdown = 30;

		kActor@ A;
		kStr secrets;
		array<bool> found( TID_SecretMarker_End - TID_SecretMarker_Start );
		for ( int i=TID_SecretMarker_Start; i<TID_SecretMarker_End; ++i )
		{
			if ( i > TID_SecretMarker_Start )
				secrets += " ";
			@A = World.GetActorByTID( i );
			if ( A is null || !A.IsPersistentMarked() )
			{
				found[ i - TID_SecretMarker_Start ] = false;
				secrets += "-";
				continue;
			}
			found[ i - TID_SecretMarker_Start ] = true;
			switch ( i )
			{
				case TID_SecretMarker_Sewer:
					secrets += "" + (i - TID_SecretMarker_Start + 1) +"A";
					break;
				case TID_SecretMarker_House:
					secrets += "" + (TID_SecretMarker_Sewer - TID_SecretMarker_Start + 1) +"B";
					break;
				default:
					if ( i > TID_SecretMarker_House )
						secrets += "" + (i - TID_SecretMarker_Start);
					else
						secrets += "" + (i - TID_SecretMarker_Start + 1);
			}
		}
		if ( !found[ TID_SecretMarker_House - TID_SecretMarker_Start ]
		   && found[ TID_SecretMarker_Sewer - TID_SecretMarker_Start ] )
			Game.PrintLine( "break and enter", 0 );
		else if ( !found[ TID_SecretMarker_Cliff - TID_SecretMarker_Start ] )
			Game.PrintLine( "look out below", 0 );
		else if ( !found[ TID_SecretMarker_Sewer - TID_SecretMarker_Start ] )
			Game.PrintLine( "muck about", 0 );
		else if ( !found[ TID_SecretMarker_Temple - TID_SecretMarker_Start ] )
			Game.PrintLine( "don't believe your eyes", 0 );
		else if ( !found[ TID_SecretMarker_Outside - TID_SecretMarker_Start ] )
			Game.PrintLine( "go rock climbing", 0 );
		else
			Game.PrintLine( "Well Done!", 0 );
		Game.PrintLine( "", 1 );
		Game.PrintLine( "", 2 );
		Game.PrintLine( secrets, 3 );
		Game.PrintLine( "", 4 );
		Game.PrintLine( "Secrets Found:", 5 );
//		Game.PrintLine( "", 6 );
//		Game.PrintLine( "Level Complete", 7 );
	}
	$restart;
}
